<?php


/*
 * Created on Sep 29, 2007
 * Author: keith
 * Project: Notify Unconfirmed subscribers
 */


class nus_feedBurner extends nus_Base {

	var $baseURL;
	var $subscriberURL;
	var $loginURL;
	var $classCookies;
	var $currCookie;
	var $myName;
	var $username;
	var $password;
	var $loggedIn;
	var $nosey;
	var $allFeeders = array ();
	var $nextURL;
  var $newAccount = false;


	function nus_feedBurner($username, $password, $newaccount = false) {
		$this->myName = 'feedburner';
		$this->username = $username;
		$this->password = $password;
    $this->newAccount = $newaccount;
    
    if($newaccount) {
      $this->baseURL = 'http://feedburner.google.com/fb/a/myfeeds';
      $this->subscriberURL = 'http://feedburner.google.com/fb/a/emailsyndication?output=report&format=csv&id=';
      $this->loginURL = 'https://www.google.com/accounts/ServiceLoginAuth?service=feedburner';
    }
		else {
      $this->baseURL = 'http://www.feedburner.com';
      $this->subscriberURL = 'http://www.feedburner.com/fb/a/emailsyndication?output=report&format=csv&id=';
      $this->loginURL = 'https://www.feedburner.com/fb/a/loginSubmit';
    }
		
		$this->currCookie = $this->myName . $username . $this->random();
		$this->loggedIn = false;
		$this->nosey = new nus_Base($this->baseURL, $this->currCookie);
	}

	function login() {
		if (!$this->username && !$this->password && !($this->nosey->isReady)) {
			echo 'Cannot run without user name and password or Nosey was not instantiated.';
			$this->loggedIn = false;
			return false;
		}
    return $this->newAccount ? $this->login_new() : $this->login_old();
	}
  
  function login_old() {
		$postData = 'userId=' . $this->username . '&password=' . $this->password . '&ticket=';
		//$this->nosey->setURL($this->loginURL);
		if (!$this->nosey->loadPage($this->loginURL, true, $postData)) {
			echo "Perhaps you provided a wrong username or password. Please try again.";
			$this->loggedIn = false;
			return false;
		}

		$loginData = $this->nosey->getData();
		preg_match('#(.*?)0;URL=(.*?)"#s', $loginData, $matcher);
		$this->nextURL = $matcher[2];
		if (!$this->nextURL) {
			$this->loggedIn = false;
			return false;
		}
		return true;
  }
  
  function login_new() {
    $postData = 'service=feedburner&continue=http://feedburner.google.com/fb/a/myfeeds&Email=' . $this->username . '&Passwd=' . $this->password . '&PersistentCookie=yes&rmShown=1&signIn=Sign+In&asts=&GALX=';
		//$this->nosey->setURL($this->loginURL);
		if (!$this->nosey->loadPage($this->loginURL, true, $postData)) {
			echo "Perhaps you provided a wrong username or password. Please try again.";
			$this->loggedIn = false;
			return false;
		}

		$loginData = $this->nosey->getData();
    preg_match('/(.*?)The username or password you entered is incorrect(.*?)"/is', $loginData, $matcher);
    if($matcher) {
      $this->loggedIn = false;
			return false;
    }
		$loginData = str_replace("&#39;", "'", $loginData);
    preg_match('/(.*?)0; url=\'(.*?)\'"/is', $loginData, $matcher);
		$this->nextURL = $matcher[2];
    
		if (!$this->nextURL) {
			$this->loggedIn = false;
			return false;
		}
    if (!$this->nosey->loadPage($this->nextURL)) {
      $this->loggedIn = false;
			return false;
    }
    
		return true;
  }

  function get_unconfirmed_subscribers() {
    if(! $this->loggedIn && !($this->nosey->isReady)) {
			echo 'Cannot run without logging or nosey being instantiated.';
			return false;
		}
    return $this->newAccount ? $this->get_unconfirmed_subscribers_new() : $this->get_unconfirmed_subscribers_old();
  }
  
	function get_unconfirmed_subscribers_new() {
		if (!$this->nosey->loadPage($this->baseURL)) {
      $this->loggedIn = false;
			return false;
    }
    $feedData = $this->nosey->getData();
		$feeds = array();
		preg_match_all('#(.*?)fb/a/dashboard(.*?)\?id=(.*?)&(.*?)"#s', $feedData, $matcher);
		$theFeeds = $matcher[3];
		$myFeeds = array_unique($theFeeds);
		foreach ($myFeeds as $feed) {
			$feedSubs = $this->subscriberURL . $feed;
      
			preg_match('#<a href="(.*?)fb/a/dashboard(.*?)\?id='.$feed.'&(.*?)"(.*?)>(.*?)</a>#s', $feedData, $namer);
			$feedName = $namer[5];
			if ($this->nosey->loadPage($feedSubs)) {
				$feeders = $this->nosey->returnData;
				$feeders = str_replace("Email,Subscribed,Status,", "", $feeders);
				$rows = explode("\n",  $feeders);
				$feederEmails = array();
				foreach($rows as $row) {
					$cols = explode(",", $row);
					if(strcasecmp(trim($cols[2]), 'Pending Verification') == 0) {
						$feederEmails[] = $cols[0];
					}
				}
				$feeds[$feedName]['id'] = $feed;
				$feeds[$feedName]['emails'] = $feederEmails;
			}
		}
		return $feeds;
	}
  
  function get_unconfirmed_subscribers_old() {
		if (! $this->nosey->loadPage($this->nextURL)) {
			echo "OOPS seems something went wrong or we cannot fetch your subscribers. Please try again.";
			return false;
		}

		$feedData = $this->nosey->getData();
		$feeds = array();
		preg_match_all('#(.*?)fb/a/dashboard(.*?)\?id=(.*?)"#s', $feedData, $matcher);
		$theFeeds = $matcher[3];
		$myFeeds = array_unique($theFeeds);
		foreach ($myFeeds as $feed) {
			$feedSubs = $this->subscriberURL . $feed;
			preg_match('#<a href="(.*?)fb/a/dashboard(.*?)\?id='.$feed.'"(.*?)>(.*?)</a>#s', $feedData, $namer);
			$feedName = $namer[4];
			if ($this->nosey->loadPage($feedSubs)) {
				$feeders = $this->nosey->returnData;
				$feeders = str_replace("Email,Subscribed,Status,", "", $feeders);
				$rows = explode("\n",  $feeders);
				$feederEmails = array();
				foreach($rows as $row) {
					$cols = explode(",", $row);
					if(strcasecmp(trim($cols[2]), 'Pending Verification') == 0) {
						$feederEmails[] = $cols[0];
					}
				}
				$feeds[$feedName]['id'] = $feed;
				$feeds[$feedName]['emails'] = $feederEmails;
			}
		}
		return $feeds;
  }
}
?>
